
;*** interfaces
;*** IAdviseSink
;*** IAdviseSinkEx
;*** IBindCtx
;*** ICallFactory
;*** IClientSecurity
;*** IDataObject
;*** IEnumFormatETC
;*** IEnumMoniker
;*** IEnumSTATSTG
;*** IEnumUnknown
;*** IMalloc
;*** IMallocSpy
;*** IMoniker
;*** IMultiQI
;*** IPersist
;*** IPersistFile
;*** IPersistStorage
;*** IPersistStream
;*** IPSFactoryBuffer
;*** IRpcChannelBuffer
;*** IRpcChannelBuffer2
;*** IRpcProxyBuffer
;*** IRpcStubBuffer
;*** IRunnableObject
;*** IRunningObjectTable
;*** ISequentialStream
;*** IStorage
;*** IStream

FORMATETC STRUCT DWORD
		cfFormat		WORD ?
		reserved		WORD ?
		ptd 			DWORD ?
		dwAspect		DWORD ?
		lindex			LONG ?
		tymed			DWORD ?
FORMATETC ENDS

DATADIR_GET equ 1
DATADIR_SET equ 2


TYMED_HGLOBAL	equ 1
TYMED_FILE		equ 2
TYMED_ISTREAM	equ 4
TYMED_ISTORAGE	equ 8
TYMED_GDI		equ 16
TYMED_MFPICT	equ 32
TYMED_ENHMF 	equ 64
TYMED_NULL		equ 0

STGMEDIUM STRUCT DWORD
		tymed			DWORD ?
		union
		hBitmap 		DWORD ?
		hMetaFilePict	DWORD ?
		hEnhMetaFile	DWORD ?
		hGlobal 		DWORD ?
		lpszFileName	DWORD ?
		pstm			DWORD ?
		pstg			DWORD ?
		ends
		pUnkForRelease	DWORD ?
STGMEDIUM ENDS

STGTY_STORAGE	equ 1
STGTY_STREAM	equ 2
STGTY_LOCKBYTES equ 3
STGTY_PROPERTY	equ 4

BIND_OPTS struct
cbStruct	DWORD ?
grfFlags	DWORD ?
grfMode 	DWORD ?
dwTickCountDeadline DWORD ?
BIND_OPTS ends

LPBIND_OPTS typedef ptr BIND_OPTS

BIND_OPTS2 struct
cbStruct	DWORD ?
grfFlags	DWORD ?
grfMode 	DWORD ?
dwTickCountDeadline DWORD ?
dwTrackFlags	DWORD ?
dwClassContext	DWORD ?
locale			DWORD ? 	;is a LCID
pServerInfo 	LPVOID ?
BIND_OPTS2 ends

LPBIND_OPTS2 typedef ptr BIND_OPTS2

ADVF_NODATA 	equ 1
ADVF_PRIMEFIRST equ 2
ADVF_ONLYONCE	equ 4
ADVF_DATAONSTOP equ 64
ADVFCACHE_NOHANDLER equ 8
ADVFCACHE_FORCEBUILTIN	equ 16
ADVFCACHE_ONSAVE	equ 32

ifndef ULARGE_INTEGER
ULARGE_INTEGER typedef QWORD
endif

STATSTG struct
pwcsName			LPOLESTR ?
type_				DWORD ?
cbSize				ULARGE_INTEGER ?
mtime				FILETIME <>
ctime				FILETIME <>
atime				FILETIME <>
grfMode 			DWORD ?
grfLocksSupported	DWORD ?
clsid				CLSID <>
grfStateBits		DWORD ?
reserved			DWORD ?
STATSTG ends

MULTI_QI struct
pIID	REFIID		?
pItf	LPUNKNOWN	?
hr		HRESULT 	?
MULTI_QI ends

ifndef LPCOAUTHINFO
LPCOAUTHINFO typedef ptr COAUTHINFO
endif
ifndef LPWORD
LPWORD typedef ptr WORD
endif

COSERVERINFO struct
dwReserved1 	DWORD	?
pwszName		LPWORD	?
pAuthInfo		LPCOAUTHINFO ?
dwReserved2    DWORD ?
COSERVERINFO ends

MKSYS_NONE				equ 0
MKSYS_GENERICCOMPOSITE	equ 1
MKSYS_FILEMONIKER		equ 2
MKSYS_ANTIMONIKER		equ 3
MKSYS_ITEMMONIKER		equ 4
MKSYS_POINTERMONIKER	equ 5
MKSYS_CLASSMONIKER		equ 7
MKSYS_OBJREFMONIKER 	equ 8
MKSYS_SESSIONMONIKER	equ 9

RPCOLEDATAREP typedef DWORD

RPCOLEMESSAGE struct
reserved1			LPVOID ?
dataRepresentation  RPCOLEDATAREP ?
Buffer			    LPVOID ?
cbBuffer		    DWORD ?
iMethod			    DWORD ?
reserved2		    LPVOID 5 dup (?)
rpcFlags		    DWORD ?
RPCOLEMESSAGE ends

PRPCOLEMESSAGE typedef ptr RPCOLEMESSAGE

;-----------------------------------------------------------------------------
; IEnumFORMATETC interface

externdef stdcall IID_IEnumFORMATETC:IID

LPENUMFORMATETC typedef ptr IEnumFORMATETC

BEGIN_INTERFACE IEnumFORMATETC, IUnknown
	STDMETHOD		Next, cFE:DWORD, pFE:ptr FORMATETC, pulFE:ptr DWORD
	STDMETHOD		Skip, cSkip:DWORD
	STDMETHOD		Reset
	STDMETHOD		Clone, ppEnum:ptr LPENUMFORMATETC
END_INTERFACE

;-----------------------------------------------------------------------------
; IMalloc interface

BEGIN_INTERFACE IMalloc, IUnknown
	; IMalloc methods
	STDMETHOD		Alloc, cb:dword
	STDMETHOD		Realloc, pv:ptr, cb:dword
	STDMETHOD		Free, pv:ptr
	STDMETHOD		GetSize, pv:ptr
	STDMETHOD		DidAlloc, pv:ptr
	STDMETHOD		HeapMinimize
END_INTERFACE

LPMALLOC typedef ptr IMalloc

;-----------------------------------------------------------------------------
; IMallocSpy interface

externdef stdcall IID_IMallocSpy:IID

BEGIN_INTERFACE IMallocSpy, IUnknown
	; IMallocSpy methods
	STDMETHOD		PreAlloc, cbRequest:dword
	STDMETHOD		PostAlloc, pActual:ptr 
	STDMETHOD		PreFree, pRequest:ptr, fSpyed:BOOL
	STDMETHOD		PostFree, fSpyed:BOOL
	STDMETHOD		PreRealloc, pRequest:ptr, cbRequest:dword,ppNewRequest:ptr ptr, fSpyed:BOOL
	STDMETHOD		PostRealloc, pActual:ptr, fSpyed:BOOL
	STDMETHOD		PreGetSize, pRequest:ptr, fSpyed:BOOL
	STDMETHOD		PostGetSize, cbActual:DWORD, fSpyed:BOOL
	STDMETHOD		PreDidAlloc, pRequest:ptr, fSpyed:BOOL
	STDMETHOD		PostDidAlloc, pRequest:ptr, fSpyed:BOOL, fActual:DWORD
	STDMETHOD		PreHeapMinimize
	STDMETHOD		PostHeapMinimize
END_INTERFACE

LPMALLOCSPY typedef ptr IMallocSpy

;-----------------------------------------------------------------------------
;interface ISequentialStream

BEGIN_INTERFACE ISequentialStream
	; IUnknown methods
	STDMETHOD		QueryInterface, riid:DWORD, ppv:DWORD
	STDMETHOD		AddRef
	STDMETHOD		Release
	; ISequentialStream methods
	STDMETHOD		Read,	pv:ptr, cb:DWORD, pcbRead:ptr DWORD 
	STDMETHOD		Write,	pv:ptr, cb:DWORD, pcbWritten:ptr DWORD
END_INTERFACE

LPSEQUENTIALSTREAM typedef ptr ISequentialStream

;interface IStream
;-----------------------------------------------------------------------------

externdef stdcall IID_IStream:IID

BEGIN_INTERFACE IStream
	; IUnknown methods
	STDMETHOD		QueryInterface, riid:DWORD, ppv:DWORD
	STDMETHOD		AddRef
	STDMETHOD		Release
	; ISequentialStream methods
	STDMETHOD		Read,	pv:ptr, cb:DWORD, pcbRead:ptr DWORD 
	STDMETHOD		Write,	pv:ptr, cb:DWORD, pcbWritten:ptr DWORD
	; IStream methods
	STDMETHOD		Seek,	dlibMove:QWORD, dwOrigin:DWORD, plibNewPosition:ptr QWORD 
	STDMETHOD		SetSize,libNewSize:QWORD
	STDMETHOD		CopyTo, pstm:ptr IStream, cb:QWORD, pcbRead:ptr QWORD, pcbWritten:ptr QWORD 
	STDMETHOD		Commit, grfCommitFlags:DWORD
	STDMETHOD		Revert
	STDMETHOD		LockRegion, libOffset:QWORD, cb:QWORD, dwLockType:DWORD
	STDMETHOD		UnlockRegion, libOffset:QWORD, cb:QWORD, dwLockType:DWORD
	STDMETHOD		Stat	,:ptr, grfStatFlag:DWORD
	STDMETHOD		Clone	,:ptr ptr IStream
END_INTERFACE

ifndef LPSTREAM
LPSTREAM typedef ptr IStream
endif

;interface IStorage 
;-----------------------------------------------------------------------------

externdef stdcall IID_IStorage:IID

BEGIN_INTERFACE IStorage
	; IUnknown methods
	STDMETHOD		QueryInterface, riid:DWORD, ppv:DWORD
	STDMETHOD		AddRef
	STDMETHOD		Release
	; IStorage methods
	STDMETHOD		CreateStream, pwcsName:ptr byte, grfMode:DWORD, reserved1:DWORD, reserved2:DWORD, ppstm:ptr LPSTREAM
	STDMETHOD		OpenStream, pwcsName:ptr byte, reserved1:DWORD, grfMode:DWORD, reserved2:DWORD, ppstm:ptr LPSTREAM
	STDMETHOD		CreateStorage, pwcsName:ptr byte, grfMode:DWORD, dwStgFmt:DWORD, reserved2:DWORD, ppstg:ptr ptr IStorage
	STDMETHOD		OpenStorage, pwcsName:ptr byte, pstgPriority:ptr IStorage, grfMode:DWORD, snbExclude:DWORD, reserved:DWORD, ppstg:ptr ptr IStorage
	STDMETHOD		CopyTo, ciidExclude:DWORD, rgiidExclude:ptr IID, snbExclude:DWORD, pstgDest:ptr IStorage
	STDMETHOD		MoveElementTo, pwcsName:ptr byte, pstgDest:ptr IStorage, pwcsNewName:ptr byte, grfFlags:DWORD
	STDMETHOD		Commit, grfCommitFlags:DWORD
	STDMETHOD		Revert
	STDMETHOD		EnumElements, reserved1:DWORD, reserved2:DWORD, reserved3:DWORD, ppenum:ptr ptr
	STDMETHOD		DestroyElement, pwcsName:ptr byte
	STDMETHOD		RenameElement, pwcsOldName:ptr byte, pwcsNewName:ptr byte
	STDMETHOD		SetElementTimes, pwcsName:ptr byte, pctime:ptr FILETIME, patime:ptr FILETIME, pmtime:ptr FILETIME
	STDMETHOD		SetClass, clsid:ptr GUID
	STDMETHOD		SetStateBits, grfStateBits:DWORD, grfMask:DWORD
	STDMETHOD		Stat, pstatstg:ptr, grfStatFlag:DWORD
END_INTERFACE

LPSTORAGE typedef ptr IStorage


;interface IPersist
;-----------------------------------------------------------------------------

externdef stdcall IID_IPersist:IID

BEGIN_INTERFACE IPersist
	; IUnknown methods
	STDMETHOD		QueryInterface, riid:DWORD, ppv:DWORD
	STDMETHOD		AddRef
	STDMETHOD		Release
	; IPersist methods
	STDMETHOD		GetClassID		, pClsID:ptr GUID
END_INTERFACE

LPPERSIST typedef ptr IPersist


;interface IPersistStorage
;-----------------------------------------------------------------------------

externdef stdcall IID_IPersistStorage:IID

BEGIN_INTERFACE IPersistStorage, IUnknown
	; IPersist methods
	STDMETHOD		GetClassID		, pClsID:ptr GUID
	; IPersistStorage methods
	STDMETHOD		IsDirty 		
	STDMETHOD		InitNew 		, pStg:LPSTORAGE
	STDMETHOD		Load			, pStg:LPSTORAGE
	STDMETHOD		Save			, pStg:LPSTORAGE, fSameAsLoad:dword
	STDMETHOD		SaveCompleted	, pStgNew:LPSTORAGE
	STDMETHOD		HandsOffStorage 
END_INTERFACE

LPPERSISTSTORAGE typedef ptr IPersistStorage

;interface IPersistStream
;-----------------------------------------------------------------------------

externdef stdcall IID_IPersistStream:IID

BEGIN_INTERFACE IPersistStream, IUnknown
	; IPersist methods
	STDMETHOD		GetClassID		, pClsID:ptr GUID
	; IPersistStream methods
	STDMETHOD		IsDirty 		
	STDMETHOD		Load			, pStm:LPSTREAM
	STDMETHOD		Save			, pStm:LPSTREAM, fClearDirty:BOOL
	STDMETHOD		GetSizeMax		, pcbSize:ptr ULARGE_INTEGER
END_INTERFACE

LPPERSISTSTREAM typedef ptr IPersistStream


;interface IPersistFile
;-----------------------------------------------------------------------------

externdef stdcall IID_IPersistFile:IID

BEGIN_INTERFACE IPersistFile, IPersist
	STDMETHOD		IsDirty 		
	STDMETHOD		Load			, pszFileName:ptr WORD, :DWORD
	STDMETHOD		Save			, pszFileName:ptr WORD, :BOOL
	STDMETHOD		SaveCompleted	, pszFileName:ptr WORD
	STDMETHOD		GetCurFile		, pszFileName:ptr ptr WORD
END_INTERFACE

LPPERSISTFILE typedef ptr IPersistFile

;-----------------------------------------------------------------------------
; IDataObject interface

externdef stdcall IID_IDataObject:IID

BEGIN_INTERFACE IDataObject
	; IUnknown methods
	STDMETHOD		QueryInterface, riid:DWORD, ppv:DWORD
	STDMETHOD		AddRef
	STDMETHOD		Release
	; IInterface methods
	STDMETHOD		GetData, pFE:DWORD, pSTM:DWORD
	STDMETHOD		GetDataHere, pFE:DWORD, pSTM:DWORD
	STDMETHOD		QueryGetData, pFE:DWORD
	STDMETHOD		GetCanonicalFormatEtc, pFEIn:DWORD, pFEOut:DWORD
	STDMETHOD		SetData, pFE:DWORD, pSTM:DWORD, fRelease:DWORD
	STDMETHOD		EnumFormatEtc, dwDir:DWORD, ppEnum:DWORD
	STDMETHOD		DAdvise, pFE:DWORD, dwFlags:DWORD, pIAdviseSink:DWORD, pdwConn:DWORD
	STDMETHOD		DUnadvise, dwConn:DWORD
	STDMETHOD		EnumDAdvise, ppEnum:DWORD
END_INTERFACE


LPDATAOBJECT typedef ptr IDataObject

;-----------------------------------------------------------------------------
; IAdviseSink interface

externdef stdcall IID_IAdviseSink:IID

BEGIN_INTERFACE IAdviseSink
	; IUnknown methods
	STDMETHOD		QueryInterface, riid:DWORD, ppv:DWORD
	STDMETHOD		AddRef
	STDMETHOD		Release
	; IAdviseSink methods
	STDMETHOD		OnDataChange	,:ptr, :ptr
	STDMETHOD		OnViewChange	,:dword, :sdword
	STDMETHOD		OnRename		,:ptr
	STDMETHOD		OnSave
	STDMETHOD		OnClose
END_INTERFACE

LPADVISESINK typedef ptr IAdviseSink


;-----------------------------------------------------------------------------
; IAdviseSinkEx interface

externdef stdcall IID_IAdviseSinkEx:IID

BEGIN_INTERFACE IAdviseSinkEx, IAdviseSink
	STDMETHOD		OnViewStatusChange	,:DWORD
END_INTERFACE

LPADVISESINKEX typedef ptr IAdviseSinkEx


;-----------------------------------------------------------------------------
; IMoniker interface

BEGIN_INTERFACE IMoniker, IPersistStream
	STDMETHOD		BindToObject, pbc:ptr IBindCtx, pmkToLeft:ptr IMoniker,riidResult:REFIID,ppvResult:ptr ptr
	STDMETHOD		BindToStorage, pbc:ptr IBindCtx, pmkToLeft:ptr IMoniker,riid:REFIID,ppvObj:ptr ptr
	STDMETHOD		Reduce, pbc:ptr IBindCtx, dwReduceHowFar:DWORD, ppmkToLeft:ptr ptr IMoniker, ppmkReduced:ptr ptr IMoniker
	STDMETHOD		ComposeWith, pmkRight:ptr IMoniker, fOnlyIfNotGeneric:BOOL, ppmkComposite:ptr ptr IMoniker
	STDMETHOD		Enum, fForward:BOOL, ppenumMoniker:ptr ptr IEnumMoniker
	STDMETHOD		IsEqual, pmkOtherMoniker:ptr IMoniker
	STDMETHOD		Hash, pdwHash:ptr DWORD
	STDMETHOD		IsRunning, pbc:ptr IBindCtx, pmkToLeft:ptr IMoniker, pmkNewlyRunning:ptr IMoniker
	STDMETHOD		GetTimeOfLastChange, pbc:ptr IBindCtx, pmkToLeft:ptr IMoniker, pFileTime:ptr FILETIME
	STDMETHOD		Inverse, ppmk:ptr ptr IMoniker
	STDMETHOD		CommonPrefixWith, pmkOther:ptr IMoniker, ppmkPrefix:ptr ptr IMoniker
	STDMETHOD		RelativePathTo, pmkOther:ptr IMoniker, ppmkRelPath:ptr ptr IMoniker
	STDMETHOD		GetDisplayName, pbc:ptr IBindCtx, pmkToLeft:ptr IMoniker, ppszDisplayName:ptr ptr WORD
	STDMETHOD		ParseDisplayName, pbc:ptr IBindCtx, pmkToLeft:ptr IMoniker, pszDisplayName:ptr WORD, pchEaten:ptr DWORD, ppmkOut:ptr ptr IMoniker
	STDMETHOD		IsSystemMoniker, pdwMksys:ptr DWORD
END_INTERFACE

LPMONIKER typedef ptr IMoniker

;-----------------------------------------------------------------------------
; IBindCtx interface

externdef stdcall IID_IBindCtx:IID

BEGIN_INTERFACE IBindCtx
	; IUnknown methods
	STDMETHOD		QueryInterface, riid:DWORD, ppv:DWORD
	STDMETHOD		AddRef
	STDMETHOD		Release
	; IBindCtx methods
	STDMETHOD		RegisterObjectBound, :LPUNKNOWN
	STDMETHOD		RevokeObjectBound, :LPUNKNOWN
	STDMETHOD		ReleaseBoundObjects, 
	STDMETHOD		SetBindOptions, :ptr
	STDMETHOD		GetBindOptions, :ptr
	STDMETHOD		GetRunningObjectTable, :ptr ptr
	STDMETHOD		RegisterObjectParam, pszKey:LPOLESTR, :LPUNKNOWN
	STDMETHOD		GetObjectParam, pszKey:LPOLESTR, :ptr LPUNKNOWN
	STDMETHOD		EnumObjectParam, :ptr ptr
	STDMETHOD		RevokeObjectParam, pszKey:LPOLESTR
END_INTERFACE

LPBINDCTX typedef ptr IBindCtx
LPBC typedef ptr IBindCtx

;-----------------------------------------------------------------------------
; IRunnableObject interface

externdef stdcall IID_IRunnableObject:IID

BEGIN_INTERFACE IRunnableObject
	; IUnknown methods
	STDMETHOD		QueryInterface, riid:DWORD, ppv:DWORD
	STDMETHOD		AddRef
	STDMETHOD		Release
	; IRunnableObject methods
	STDMETHOD		GetRunningClass, lpClsid:ptr CLSID
	STDMETHOD		Run, pbc:LPBINDCTX
	STDMETHOD		IsRunning
	STDMETHOD		LockRunning, fLock:BOOL, fLastUnlockCloses:BOOL
	STDMETHOD		SetContainedObject, fContained:BOOL
END_INTERFACE

LPRUNNABLEOBJECT typedef ptr IRunnableObject

;-----------------------------------------------------------------------------
; IEnumSTATSTG interface

BEGIN_INTERFACE IEnumSTATSTG, IUnknown
	STDMETHOD		Next, celt:DWORD, rgelt:ptr STATSTG, pceltFetchedFE:ptr DWORD
	STDMETHOD		Skip, cSkip:DWORD
	STDMETHOD		Reset
	STDMETHOD		Clone, ppEnum:ptr ptr IEnumSTATSTG
END_INTERFACE

LPENUMSTATSTG typedef ptr IEnumSTATSTG

;-----------------------------------------------------------------------------
; IEnumUnknown interface

externdef stdcall IID_IEnumUnknown:IID

BEGIN_INTERFACE IEnumUnknown, IUnknown
	STDMETHOD	Next, celt:DWORD, rgelt:ptr LPUNKNOWN, pceltFetchedFE:ptr DWORD
	STDMETHOD	Skip, cSkip:DWORD
	STDMETHOD	Reset
	STDMETHOD	Clone, ppEnum:ptr ptr IEnumUnknown
END_INTERFACE

LPENUMUNKNOWN typedef ptr IEnumUnknown

;-----------------------------------------------------------------------------
; IMultiQI interface

externdef stdcall IID_IMultiQI:IID

BEGIN_INTERFACE IMultiQI, IUnknown
	STDMETHOD	QueryMultipleInterfaces, :DWORD, pMQIs:ptr MULTI_QI
END_INTERFACE

LPMULTIQI typedef ptr IMultiQI

;-----------------------------------------------------------------------------
; IEnumMoniker interface

externdef stdcall IID_IEnumMoniker:IID

BEGIN_INTERFACE IEnumMoniker, IUnknown
	STDMETHOD	Next, celt:DWORD, rgelt:ptr LPMONIKER, pceltFetched:ptr DWORD
	STDMETHOD	Skip, celt:DWORD
	STDMETHOD	Reset
	STDMETHOD	Clone, ppEnum:ptr ptr IEnumMoniker
END_INTERFACE

LPENUMMONIKER typedef ptr IEnumMoniker

;-----------------------------------------------------------------------------
; IRunningObjectTable interface

externdef stdcall IID_IRunningObjectTable:IID

BEGIN_INTERFACE IRunningObjectTable, IUnknown
	STDMETHOD	Register, grfFlags:DWORD, punkObject:LPUNKNOWN, pmkObjectName:LPMONIKER, pdwRegister:ptr DWORD
	STDMETHOD	Revoke, dwRegister:DWORD
	STDMETHOD	IsRunning, pmkObjectName:LPMONIKER
	STDMETHOD	GetObject_, pmkObjectName:LPMONIKER, ppunkObject:ptr LPUNKNOWN
	STDMETHOD	NoteChangeTime, dwRegister:DWORD, pfiletime:ptr FILETIME
	STDMETHOD	GetTimeOfLastChange, pmkObjectName:LPMONIKER, pfiletime:ptr FILETIME
	STDMETHOD	EnumRunning, ppenumMoniker:ptr LPENUMMONIKER
END_INTERFACE

LPRUNNINGOBJECTTABLE typedef ptr IRunningObjectTable

;-----------------------------------------------------------------------------
; ICallFactory interface

externdef stdcall IID_ICallFactory:IID

BEGIN_INTERFACE ICallFactory, IUnknown
	STDMETHOD	CreateCall, riid1:REFIID, pUnk:LPUNKNOWN, riid2:REFIID, ppObj:ptr LPUNKNOWN
END_INTERFACE

LPCALLFACTORY typedef ptr ICallFactory

;-----------------------------------------------------------------------------
; IClientSecurity interface

externdef stdcall IID_IClientSecurity:IID

BEGIN_INTERFACE IClientSecurity, IUnknown
	STDMETHOD	QueryBlanket	,pProxy:LPUNKNOWN, pAuthnSvc:ptr DWORD, pAuthzSvc:ptr DWORD, pServerPrincName:ptr ptr WORD, pAuthnLevel:ptr DWORD, pImpLevel:ptr DWORD, pAuthInfo:ptr LPVOID, pCapabilites:ptr DWORD
	STDMETHOD	SetBlanket		,pProxy:LPUNKNOWN, dwAuthnSvc:DWORD, dwAuthzSvc:DWORD, pServerPrincName:ptr WORD, dwAuthnLevel:DWORD, dwImpLevel:DWORD, pAuthInfo:LPVOID, dwCapabilites:DWORD
	STDMETHOD	CopyProxy		,pProxy:LPUNKNOWN, ppCopy:ptr LPUNKNOWN
END_INTERFACE

LPCLIENTSECURITY typedef ptr IClientSecurity

;-----------------------------------------------------------------------------
; IPSFactoryBuffer interface

externdef stdcall IID_IPSFactoryBuffer:IID

BEGIN_INTERFACE IPSFactoryBuffer, IUnknown
	STDMETHOD	CreateProxy, pUnkOuter:LPUNKNOWN, riid:REFIID, ppProxy:ptr ptr IRpcProxyBuffer, ppv:ptr LVVOID
	STDMETHOD	CreateStub, riid:REFIID, pUnkServer:LPUNKNOWN, ppStub:ptr ptr IRpcStubBuffer
END_INTERFACE

LPPSFACTORYBUFFER typedef ptr IPSFactoryBuffer

;-----------------------------------------------------------------------------
; IRpcChannelBuffer interface

externdef stdcall IID_IRpcChannelBuffer:IID

BEGIN_INTERFACE IRpcChannelBuffer, IUnknown
	STDMETHOD	GetBuffer	,pMessage:ptr RPCOLEMESSAGE, riid:REFIID
	STDMETHOD	SendReceive	,pMessage:ptr RPCOLEMESSAGE, pStatus:ptr DWORD
	STDMETHOD	FreeBuffer	,pMessage:ptr RPCOLEMESSAGE
	STDMETHOD	GetDestCtx	,pdwDestContext:ptr DWORD, ppvDestContext:ptr LPVOID
	STDMETHOD	IsConnected
END_INTERFACE

LPRPCCHANNELBUFFER typedef ptr IRpcChannelBuffer

;-----------------------------------------------------------------------------
; IRpcChannelBuffer2 interface

externdef stdcall IID_IRpcChannelBuffer2:IID

BEGIN_INTERFACE IRpcChannelBuffer2, IRpcChannelBuffer
	STDMETHOD	GetProtocolVersion	,pdwVersion:ptr DWORD
END_INTERFACE

LPRPCCHANNELBUFFER2 typedef ptr IRpcChannelBuffer2


;-----------------------------------------------------------------------------
; IRpcProxyBuffer interface

externdef stdcall IID_IRpcProxyBuffer:IID

BEGIN_INTERFACE IRpcProxyBuffer, IUnknown
	STDMETHOD	Connect, pRpcChannelBuffer:ptr IRpcChannelBuffer
	STDMETHOD	Disconnect
END_INTERFACE

LPRPCPROXYBUFFER typedef ptr IRpcProxyBuffer

;-----------------------------------------------------------------------------
; IRpcStubBuffer interface

externdef stdcall IID_IRpcStubBuffer:IID

BEGIN_INTERFACE IRpcStubBuffer, IUnknown
	STDMETHOD	Connect, pUnkServer:LPUNKNOWN
	STDMETHOD	Disconnect
	STDMETHOD	Invoke_, _prpcmsg:ptr RPCOLEMESSAGE, _pRpcChannelBuffer:ptr IRpcChannelBuffer
	STDMETHOD	IsIIDSupported, riid:REFIID
	STDMETHOD	CountRefs
	STDMETHOD	DebugServerQueryInterface, ppv:ptr LPVOID
	STDMETHOD	DebugServerRelease, pv:LPVOID
END_INTERFACE

LPRPCSTUBBUFFER typedef ptr IRpcStubBuffer
