
; interfaces
; IOleObject
; IOleWindow
; IOleClientSite
; IOleInPlaceUIWindow
; IOleInPlaceFrame
; IOleInPlaceObject
; IOleInPlaceActiveObject
; IViewObject
; IViewObject2
; IDropTarget
; IDropSource
; IOleAdviseHolder
; IEnumOLEVERB

OLEMENUGROUPWIDTHS struct
_width sdword 6 dup (?)
OLEMENUGROUPWIDTHS ends

BORDERWIDTHS typedef RECT

OLECLOSE_SAVEIFDIRTY	equ 0
OLECLOSE_NOSAVE			equ 1
OLECLOSE_PROMPTSAVE		equ 2

OLEINPLACEFRAMEINFO struct
cb				DWORD	?
fMDIApp			BOOL	?
hwndFrame		HWND    ?
haccel			HACCEL  ?
cAccelEntries   DWORD	?
OLEINPLACEFRAMEINFO ends


OLEVERB struct
lVerb           SDWORD  ?
lpszVerbName    LPOLESTR ?
fuFlags         DWORD   ?
grfAttribs      DWORD   ?
OLEVERB ends

USERCLASSTYPE_FULL		equ 1
USERCLASSTYPE_SHORT		equ 2
USERCLASSTYPE_APPNAME	equ 3

OLEMISC_RECOMPOSEONRESIZE			equ 000000001h
OLEMISC_ONLYICONIC					equ 000000002h
OLEMISC_INSERTNOTREPLACE			equ 000000004h
OLEMISC_STATIC						equ 000000008h
OLEMISC_CANTLINKINSIDE				equ 000000010h
OLEMISC_CANLINKBYOLE1				equ 000000020h
OLEMISC_ISLINKOBJECT				equ 000000040h
OLEMISC_INSIDEOUT					equ 000000080h
OLEMISC_ACTIVATEWHENVISIBLE			equ 000000100h
OLEMISC_RENDERINGISDEVICEINDEPENDENT equ 000000200h
OLEMISC_INVISIBLEATRUNTIME			EQU 000000400h
OLEMISC_ALWAYSRUN					EQU 000000800h
OLEMISC_ACTSLIKEBUTTON				EQU 000001000h
OLEMISC_ACTSLIKELABEL				EQU 000002000h
OLEMISC_NOUIACTIVATE				EQU 000004000h
OLEMISC_ALIGNABLE					EQU 000008000h
OLEMISC_SIMPLEFRAME 				EQU 000010000h
OLEMISC_SETCLIENTSITEFIRST			EQU 000020000h
OLEMISC_IMEMODE 					EQU 000040000h
OLEMISC_IGNOREACTIVATEWHENVISIBLE	equ 000080000h
OLEMISC_WANTSTOMENUMERGE			equ 000100000h
OLEMISC_SUPPORTSMULTILEVELUNDO		equ 000200000h

; IOleObject interface
;------------------------------------------------------------------------------------

externdef stdcall IID_IOleObject:ptr IID

BEGIN_INTERFACE IOleObject
    ; IUnknown methods
    STDMETHOD QueryInterface, riid:DWORD, ppv:DWORD
    STDMETHOD AddRef
    STDMETHOD Release
    ; IOleObject methods
	STDMETHOD SetClientSite 		, :ptr
	STDMETHOD GetClientSite 		, :ptr
	STDMETHOD SetHostNames			, :ptr byte, :ptr byte
	STDMETHOD Close 				, :dword
	STDMETHOD SetMoniker			, :dword, :ptr
	STDMETHOD GetMoniker			, :dword, :dword, :ptr
	STDMETHOD InitFromData			, :ptr , :dword, :dword
	STDMETHOD GetClipboardData		, :dword, :ptr
	STDMETHOD DoVerb				, :dword, :ptr MSG, :ptr, :dword, :HWND, :ptr
	STDMETHOD EnumVerbs 			, :ptr
	STDMETHOD Update					   
	STDMETHOD IsUpToDate				   
	STDMETHOD GetUserClassID		, :ptr
	STDMETHOD GetUserType			, :dword ,:ptr
	STDMETHOD SetExtent 			, :dword ,:ptr
	STDMETHOD GetExtent 			, :dword ,:ptr
	STDMETHOD Advise				, :ptr, :ptr
	STDMETHOD Unadvise				, :dword
	STDMETHOD EnumAdvise			, :ptr
	STDMETHOD GetMiscStatus 		, :dword, :ptr
	STDMETHOD SetColorScheme		, :ptr
END_INTERFACE

LPOLEOBJECT typedef ptr IOleObject

; IOleWindow interface
;------------------------------------------------------------------------------------

externdef stdcall IID_IOleWindow:ptr IID

BEGIN_INTERFACE IOleWindow
    ; IUnknown methods
    STDMETHOD       QueryInterface, riid:DWORD, ppv:DWORD
    STDMETHOD       AddRef
    STDMETHOD       Release
    ; IOleWindow methods
    STDMETHOD		GetWindow				 ,:ptr HWND
    STDMETHOD		ContextSensitiveHelp     ,:dword
END_INTERFACE

LPOLEWINDOW typedef ptr IOleWindow


; IOleClientSite interface
;------------------------------------------------------------------------------------

externdef stdcall IID_IOleClientSite:ptr IID

BEGIN_INTERFACE IOleClientSite
    ; IUnknown methods
    STDMETHOD   QueryInterface, riid:DWORD, ppv:DWORD
    STDMETHOD   AddRef
    STDMETHOD   Release
    ; IleClientSite methods
	STDMETHOD 	SaveObject
	STDMETHOD	GetMoniker	, dwAssign:DWORD, dwWhichMoniker:DWORD, ppmk:ptr ptr
	STDMETHOD	GetContainer, ppContainer:ptr ptr
	STDMETHOD	ShowObject
	STDMETHOD	OnShowWindow, fShow:DWORD
	STDMETHOD	RequestNewObjectLayout
END_INTERFACE

LPOLECLIENTSITE typedef ptr IOleClientSite


; IOleInPlaceUIWindow interface
;------------------------------------------------------------------------------------

LPOLEINPLACEACTIVEOBJECT typedef ptr IOleInPlaceActiveObject

externdef stdcall IID_IOleInPlaceUIWindow:ptr IID

BEGIN_INTERFACE IOleInPlaceUIWindow
    ; IUnknown methods
    STDMETHOD   QueryInterface, riid:DWORD, ppv:DWORD
    STDMETHOD   AddRef
    STDMETHOD   Release
    ; IOleWindow methods
    STDMETHOD		GetWindow				 ,:ptr HWND
    STDMETHOD		ContextSensitiveHelp     ,:dword
    ; IOleInPlaceUIWindow methods
    STDMETHOD		GetBorder				,:ptr RECT	
    STDMETHOD		RequestBorderSpace		,:ptr BORDERWIDTHS
    STDMETHOD		SetBorderSpace			,:ptr BORDERWIDTHS
    STDMETHOD		SetActiveObject			,:LPOLEINPLACEACTIVEOBJECT, :ptr WORD
END_INTERFACE

LPOLEINPLACEUIWINDOW typedef ptr IOleInPlaceUIWindow


; IOleInPlaceFrame interface
;------------------------------------------------------------------------------------

externdef stdcall IID_IOleInPlaceFrame:ptr IID

BEGIN_INTERFACE IOleInPlaceFrame
    ; IUnknown methods
    STDMETHOD   QueryInterface, riid:DWORD, ppv:DWORD
    STDMETHOD   AddRef
    STDMETHOD   Release
    ; IOleWindow methods
    STDMETHOD		GetWindow				 ,:ptr HWND
    STDMETHOD		ContextSensitiveHelp     ,:dword
    ; IOleInPlaceUIWindow methods
    STDMETHOD		GetBorder				,:ptr RECT	
    STDMETHOD		RequestBorderSpace		,:ptr BORDERWIDTHS
    STDMETHOD		SetBorderSpace			,:ptr BORDERWIDTHS
    STDMETHOD		SetActiveObject			,:LPOLEINPLACEACTIVEOBJECT, :ptr WORD
    ; IOleInPlaceFrame methods
    STDMETHOD		InsertMenus				,:HMENU, :ptr
    STDMETHOD		SetMenu					,:HMENU, :HANDLE, :HWND
    STDMETHOD		RemoveMenus				,:HMENU
    STDMETHOD		SetStatusText			,:ptr WORD
    STDMETHOD		EnableModeless			,:DWORD
    STDMETHOD		TranslateAccelerator	,:ptr MSG, :WORD
END_INTERFACE

LPOLEINPLACEFRAME typedef ptr IOleInPlaceFrame


; IOleInPlaceObject interface
;------------------------------------------------------------------------------------

externdef stdcall IID_IOleInPlaceObject:ptr IID

BEGIN_INTERFACE IOleInPlaceObject
    ; IUnknown methods
    STDMETHOD   QueryInterface, riid:DWORD, ppv:DWORD
    STDMETHOD   AddRef
    STDMETHOD   Release
    ; IOleWindow methods
    STDMETHOD		GetWindow				 ,:ptr HWND
    STDMETHOD		ContextSensitiveHelp     ,:dword
    ; IOleInPlaceObject methods
    STDMETHOD		InPlaceDeactivate
    STDMETHOD		UIDeactivate
    STDMETHOD		SetObjectRects			 ,:ptr RECT, :ptr RECT
    STDMETHOD		ReactivateAndUndo
END_INTERFACE

LPOLEINPLACEOBJECT typedef ptr IOleInPlaceObject


; IOleInPlaceActiveObject interface
;------------------------------------------------------------------------------------

externdef stdcall IID_IOleInPlaceActiveObject:ptr IID

BEGIN_INTERFACE IOleInPlaceActiveObject
    ; IUnknown methods
    STDMETHOD   QueryInterface, riid:DWORD, ppv:DWORD
    STDMETHOD   AddRef
    STDMETHOD   Release
    ; IOleWindow methods
    STDMETHOD		GetWindow				,:ptr HWND
    STDMETHOD		ContextSensitiveHelp    ,:dword
    ; IOleInPlaceActiveObject methods
    STDMETHOD		TranslateAccelerator    ,:ptr MSG
    STDMETHOD		OnFrameWindowActivate   ,:dword
    STDMETHOD		OnDocWindowActivate		,:dword
    STDMETHOD		ResizeBorder            ,:ptr RECT, :ptr, :dword
    STDMETHOD		EnableModeless          ,:dword
END_INTERFACE

LPOLEINPLACEACTIVEOBJECT typedef ptr IOleInPlaceActiveObject


; IViewObject interface
;------------------------------------------------------------------------------------

externdef stdcall IID_IViewObject:IID

BEGIN_INTERFACE IViewObject
    ; IUnknown methods
    STDMETHOD   QueryInterface, riid:DWORD, ppv:DWORD
    STDMETHOD   AddRef
    STDMETHOD   Release
    ; IViewObject methods
    STDMETHOD		Draw		,dwDrawAspect:DWORD, lindex:SDWORD, pvAspect:ptr, ptd:ptr, hdcTargetDev:HDC, hdcDraw:HDC, lprcBounds:ptr RECT, lprcWBounds:ptr RECT, pfnContinue:ptr, dwContinue:DWORD
    STDMETHOD		GetColorSet ,dwDrawAspect:DWORD, lindex:SDWORD, pvAspect:ptr, ptd:ptr, hicTargetDev:HDC, ppColorSet:ptr ptr
    STDMETHOD		Freeze      ,dwDrawAspect:DWORD, lindex:SDWORD, pvAspect:ptr, pdwFreeze:ptr DWORD
    STDMETHOD		Unfreeze    ,dwFreeze:DWORD
    STDMETHOD		SetAdvise	,aspects:DWORD,advf:DWORD,pAdvSink:ptr
    STDMETHOD		GetAdvise   ,pAspects:ptr DWORD,pAdvf:ptr DWORD,ppAdvSink:ptr ptr
END_INTERFACE

LPVIEWOBJECT typedef ptr IViewObject


; IViewObject2 interface
;------------------------------------------------------------------------------------

externdef stdcall IID_IViewObject2:IID

BEGIN_INTERFACE IViewObject2
    ; IUnknown methods
    STDMETHOD   QueryInterface, riid:DWORD, ppv:DWORD
    STDMETHOD   AddRef
    STDMETHOD   Release
    ; IViewObject methods
    STDMETHOD		Draw		,dwDrawAspect:DWORD, lindex:SDWORD, pvAspect:ptr, ptd:ptr, hdcTargetDev:HDC, hdcDraw:HDC, lprcBounds:ptr RECT, lprcWBounds:ptr RECT, pfnContinue:ptr, dwContinue:DWORD
    STDMETHOD		GetColorSet ,dwDrawAspect:DWORD, lindex:SDWORD, pvAspect:ptr, ptd:ptr, hicTargetDev:HDC, ppColorSet:ptr ptr
    STDMETHOD		Freeze      ,dwDrawAspect:DWORD, lindex:SDWORD, pvAspect:ptr, pdwFreeze:ptr DWORD
    STDMETHOD		Unfreeze    ,dwFreeze:DWORD
    STDMETHOD		SetAdvise	,aspects:DWORD,advf:DWORD,pAdvSink:ptr
    STDMETHOD		GetAdvise   ,pAspects:ptr DWORD,pAdvf:ptr DWORD,ppAdvSink:ptr ptr
    ; IViewObject2 methods
    STDMETHOD		GetExtent   ,dwDrawAspect:DWORD,lindex:SDWORD,ptd:ptr,lpsizel:ptr SIZEL
END_INTERFACE

LPVIEWOBJECT2 typedef ptr IViewObject2


; IDropTarget interface
;-----------------------------------------------------------------------------

DROPEFFECT_NONE		equ 0
DROPEFFECT_COPY		equ 1
DROPEFFECT_MOVE		equ 2
DROPEFFECT_LINK		equ 4
DROPEFFECT_SCROLL	equ 80000000h

BEGIN_INTERFACE IDropTarget
    ; IUnknown methods
    STDMETHOD       QueryInterface, riid:DWORD, ppv:DWORD
    STDMETHOD       AddRef
    STDMETHOD       Release
    ; IDropTarget methods
    STDMETHOD       DragEnter, pIDataSource:DWORD, grfKeyState:DWORD, ptx:DWORD, pty:DWORD, pdwEffect:DWORD
    STDMETHOD       DragOver, grfKeyState:DWORD, ptx:DWORD, pty:DWORD, pdwEffect:DWORD
    STDMETHOD       DragLeave
    STDMETHOD       Drop, pIDataSource:DWORD, grfKeyState:DWORD, ptx:DWORD, pty:DWORD, pdwEffect:DWORD
END_INTERFACE


; IDropSource interface
;-----------------------------------------------------------------------------

BEGIN_INTERFACE IDropSource
    ; IUnknown methods
    STDMETHOD       QueryInterface, riid:DWORD, ppv:DWORD
    STDMETHOD       AddRef
    STDMETHOD       Release
    ; IDropSource methods
    STDMETHOD       QueryContinueDrag, fEsc:DWORD, grfKeyState:DWORD
    STDMETHOD       GiveFeedback, dwEffect:DWORD
END_INTERFACE
;-----------------------------------------------------------------------------


; IOleAdviseHolder interface
;-----------------------------------------------------------------------------

BEGIN_INTERFACE IOleAdviseHolder
    ; IUnknown methods
    STDMETHOD       QueryInterface, riid:DWORD, ppv:DWORD
    STDMETHOD       AddRef
    STDMETHOD       Release
    ; IOleAdviseHolder methods
    STDMETHOD       Advise          ,pAdvise:ptr, pdwConnection:ptr dword
    STDMETHOD       Unadvise        ,dwConnection:dword
    STDMETHOD       EnumAdvise      ,ppenumAdvise:ptr ptr
    STDMETHOD       SendOnRename    ,pmk:ptr
    STDMETHOD       SendOnSave      
    STDMETHOD       SendOnClose     
END_INTERFACE

LPOLEADVISEHOLDER typedef ptr IOleAdviseHolder

;-----------------------------------------------------------------------------

; IEnumOLEVERB interface
;-----------------------------------------------------------------------------

BEGIN_INTERFACE IEnumOLEVERB
    ; IUnknown methods
    STDMETHOD       QueryInterface, riid:DWORD, ppv:DWORD
    STDMETHOD       AddRef
    STDMETHOD       Release
    ; IEnumOLEVERB methods
    STDMETHOD       Next, celt:DWORD, rgelt:ptr OLEVERB, pceltFetched:ptr DWORD
    STDMETHOD       Skip, celt:DWORD
    STDMETHOD       Reset
    STDMETHOD       Clone, ppenum:ptr ptr
END_INTERFACE

LPENUMOLEVERB typedef ptr IEnumOLEVERB

;//**********************************************************************
